#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int confronta (char * p1, char * p2) {
	int res = 0, i=0, j=0;
	
	while (p1[i] != '\0' || p2[j] != '\0'){
		if (p2[j] == '\0') return -1;
		if (p1[i]!=p2[j]) {
			j++;
			res ++;
		} else {
			i++;
			j++;
		}
		
	}
	
	return res;
}

void stringhe_simili (char * parola, char ** dizionario, int parole_dizionario, int * indice, int * differenza) {
	int min_indice=-1, diff, min_diff = -1, i;
	
	for (i=0; i < parole_dizionario; i++){
		diff = confronta(parola, dizionario[i]);
		if(diff != -1 &&(min_diff == -1 || min_diff > diff)) {
			min_diff = diff;
			min_indice = i;
		}
	}
	*indice = min_indice;
	*differenza = min_diff;
}

int main () {
	char parola [] = {'p','a','l','o','\0'};
	char ** dizionario;
	int indice, differenza, i;
	
	dizionario = malloc(3* sizeof(char *));

	dizionario[0]= malloc (8*sizeof(char));
	dizionario[1]= malloc (5*sizeof(char));
	dizionario[2]= malloc (6*sizeof(char));
		
	memcpy(dizionario[0], "pallone\0", 8*sizeof(char));
	memcpy(dizionario[1], "gino\0", 5*sizeof(char));
	memcpy(dizionario[2], "palco\0", 6*sizeof(char));	

	stringhe_simili (parola, dizionario, 3, &indice, &differenza);
	if (indice != -1)
		printf("La parola del dizionario piu' simle a %s e' la parola %s (indice %d, differenza %d)\n", parola, dizionario[indice], indice, differenza);
	else 
		printf("Nel dizionario non ci sono parole simili a %s\n", parola);
}