#include <stdio.h>
#include <stdlib.h>

int orizzontale (int r, int c, int m [r][c], int start_r, int start_c) {
	if (start_c + 2 >= c) return 0;
	if((m[start_r][start_c]+1 == m[start_r][start_c+1]) && (m[start_r][start_c+1] +1 == m[start_r][start_c+2])){
		printf("Orizz. Ok su %d %d %d\n", m[start_r][start_c], m[start_r][start_c+1], m[start_r][start_c+2]);
		return 1;
	} else {
		return 0;
	}	
}
int verticale (int r, int c, int m [r][c], int start_r, int start_c) {
	if (start_r +2 >= r) return 0;
	if((m[start_r][start_c]+1  == m[start_r+1][start_c]) && (m[start_r+1][start_c] +1 == m[start_r+2][start_c])) {
		printf("Vert. Ok su %d %d %d\n", m[start_r][start_c], m[start_r+1][start_c], m[start_r+2][start_c]);
		return 1;
	} else {
		return 0;
	}	
}
int diagonale (int r, int c, int m [r][c], int start_r, int start_c) {
	if (start_r+2 >= r || start_c +2 >= c) return 0;
	if((m[start_r][start_c]+1  == m[start_r+1][start_c+1]) && (m[start_r+1][start_c+1] +1 == m[start_r+2][start_c+2])) {
		printf("Diag. Ok su %d %d %d\n", m[start_r][start_c], m[start_r+1][start_c+1], m[start_r+2][start_c+2]);
		return 1;
	} else {
		return 0;
	}	
}

void terne (int r, int c, int m [r][c], int * m_i, int * m_j, int* n_terne){
	int num_terne=0, max_i=-1, max_j=-1;
	int i,j,flag;
	for (i=0; i<r; i++){
		for(j=0; j<c; j++){
			flag = 0;
			if(orizzontale(r,c,m,i,j)==1) {
				num_terne++;
				printf("Orizz. %d %d %d %d %d\n", i, j, m[i][j],m[i][j+1],m[i][j+2]);
				flag=1;
			}
			if (verticale(r,c,m,i,j)==1){
				num_terne++;
				printf("Vert. %d %d  %d %d %d\n", i, j, m[i][j],m[i+1][j],m[i+2][j]);
				flag=1;
			}
			if (diagonale(r,c,m,i,j)==1){
				num_terne++;
				printf("Diag. %d %d %d %d %d\n", i,j, m[i][j],m[i+1][j+1],m[i+2][j+2]);
				flag=1;
			}
			if (flag==1 && (max_i==-1 || m[max_i][max_j]<m[i][j])){
				max_i=i;
				max_j=j;
			}
		}
	}
	*m_i=max_i;
	*m_j=max_j;
	*n_terne=num_terne; 
}

void stampa_matrice (int r, int c, int m[r][c]){
	int i,j;
	for (i=0; i<r; i++){
		for (j=0; j<c; j++)
			printf("%5d", m[i][j]);
		printf("\n");
	}
}

int main() {
	int m[4][5] = {{1, 3, 4, 5, -5},{2, 2, 7, -4, 1},{3, 4, 3, 6, 7},{-1,5, 6, 9, 12}};
	int i,j,n_terne;
	stampa_matrice(4,5,m);
	terne(4,5,m,&i,&j,&n_terne);
	printf("Ci sono %d terne, la massima ha coordinate %d %d.\n", n_terne, i, j);
}