#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int palindroma (char * frase) {
	int i=0, j=0;
	
	while(frase[j]!= '\0') j++;
	j--;
	
	while (j>i) {
		if(frase[i]==' ') i++;
		else if (frase[j]== ' ') j--;
		else if (frase[i]!= frase[j]) {
			printf("Diversa fra %d %d, %c %c %s\n", i, j, frase[i], frase [j], frase );
			return 0;
		}
		else {
			i++;
			j--;
		}
	}
	return 1;
}

void stampa_palindrome (char ** frasi, int n_frasi) {
	int i;
	for(i=0; i<n_frasi; i++) {
		if (palindroma(frasi[i]))
			printf("%s\n", frasi[i]);
	}
}

int main () {
	char ** frasi;
	
	frasi = malloc(3* sizeof(char *));

	frasi[0]= malloc (9*sizeof(char));
	frasi[1]= malloc (50*sizeof(char));
	frasi[2]= malloc (100*sizeof(char));
	
	memcpy(frasi[0], "amo roma!\0", 9*sizeof(char));
	memcpy(frasi[1], "era coi gai nani a giocare\0", 50*sizeof(char));
	memcpy(frasi[2], "avevi   visioni d un    evo  ove nudi noi si viveva\0", 100*sizeof(char));	
		
	stampa_palindrome(frasi, 3);
}