#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
  long val;
  struct nodo * figlio_sx;
  struct nodo * figlio_dx;
} Nodo;

/* start mi dice quanti valori precedono il sottoalbero corrente  */
long riempi_albero (Nodo * albero, long start){
	
	if(albero==NULL) return start; //non devo assegnare alcun valore, quindi non modifico start
	
	start = riempi_albero(albero->figlio_sx, start); //incremento il valore di start con il numero di nodi del sottoalbero sinistro
	albero->val = ++start;	//prima di passare al sottoalbero destro, 
							//aggiungo il nodo corrente al conteggio dei valori che precedono il sottoalbero destro

	start= riempi_albero(albero->figlio_dx, start); //aggiorno start al massimo valore assegnato al sottoalbero
	return start; //restituisco tale valore al chiamante
}
void stampa_inordine (Nodo * albero){
	if (albero == NULL) return;
	stampa_inordine(albero->figlio_sx);
	printf(" %d", albero->val);
	stampa_inordine(albero->figlio_dx);
}

int main () {
	Nodo * albero, * p;
	
	albero=NULL;
	p=NULL;
	
	albero= malloc(sizeof(Nodo));
	albero->val=-1;
	albero ->figlio_sx = NULL;
	albero ->figlio_dx = NULL;
	
	albero -> figlio_sx = malloc(sizeof(Nodo));
	p=albero->figlio_sx;
	
	p->val=-1;
	p ->figlio_sx = NULL;
	p ->figlio_dx = NULL;


	
	p -> figlio_dx = malloc(sizeof(Nodo));
	p=p->figlio_dx;
	p->val=-1;
	p ->figlio_sx = NULL;
	p ->figlio_dx = NULL;

	
	albero -> figlio_dx = malloc(sizeof(Nodo));
	p=albero->figlio_dx;
	
	p->val=-1;
	p ->figlio_sx = NULL;
	p ->figlio_dx = NULL;

	printf("L'albero costruito ha %d nodi\n", riempi_albero(albero, 0));
	printf("Risultato visita in ordine: " );
	stampa_inordine(albero);
	printf("\n");

}
