#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
  long val;
  struct nodo * succ;
} Nodo;

int testa_elemento(long val, int pos) {
	if(pos%2>0) return -1;
	return (val%pos);
}

void modifica_lista(Nodo ** l, int pos){
	int res;
	Nodo * temp;
	
	if (*l == NULL) return;
	res = testa_elemento((*l)->val, pos);
	if(res == -1) {
		temp = *l;
		*l = temp->succ;
		free (temp);
		modifica_lista(l, ++pos);
	}
	else {
		(*l)->val += res;
		modifica_lista(&((*l)->succ), ++pos);
	}

}
int main () {
	Nodo * lista = NULL;
	
	modifica_lista(&lista, 1);
}
