#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int confronta_int (int i, int j) {
	if (i==j) return 0;
	return i>j ?  1:-1;
}

void scambia_int(int * i, int * j) {
	int tmp;
	tmp = *i;
	*i = *j;
	*j = tmp;
}

int confronta_riga (int * r1, int * r2, int colonne){
	int i=0;
	while(i< colonne){
		if(r1[i]>r2[i]) return 1;
		if(r1[i]<r2[i]) return -1;
		i++;
	}
	return 0;
}

void scambia_riga(int * r1, int * r2, int colonne) {
	int i;
	for (i=0; i<colonne; i++) scambia_int (&(r1[i]), &(r2[i]));
}

void bubble_sort_riga (int * v, int colonne) {
	int pass, i;
	for(pass = 1; pass < colonne; pass ++){
		for(i = 0; i<colonne-pass; i++) {
			if (confronta_int(v[i],v[i+1])==1) 
				scambia_int(&(v[i]), &(v[i+1]));
		}
	}
}

void bubble_sort_matrice(int righe, int colonne, int v[righe][colonne]) {
	int pass, i;
	for(pass = 1; pass < righe; pass ++){
		for(i = 0; i<righe-pass; i++) {
			if (confronta_riga(v[i], v[i+1], colonne)==1) 
				scambia_riga(v[i], v[i+1], colonne);
		}
	}
}

void ordina_matrice (int r, int c, int m [r][c]) {
	int i;
	
	for(i=0; i< r; i++)
		bubble_sort_riga(m[i], c);
		
	bubble_sort_matrice(r,c,m);
}

void stampa_matrice(int r, int c, int m[r][c]) {
	int i, j;
	for (i=0; i<r; i++) {
		for(j=0; j<c; j++)
			printf("%5d", m[i][j]);
		printf("\n");
	}
}

int main(){
	
	int m[4][8] = {{4, 5, 6, 2, 3, 71, 325, 53},{43, 3, 1, 54, 1, 435, 13, 6},{324 ,324, 35, 32, 8, 5, 345 , 5},{543, 87, 34, 12, 7, 5, 3, 2}};
	
	printf("Matrice originale\n");
	stampa_matrice(4,8,m);
	ordina_matrice(4,8,m);
	printf("Matrice ordinata\n");
	stampa_matrice(4,8,m);

}