#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
  long val;
  struct nodo * figlio_sx;
  struct nodo * figlio_dx;
} Nodo;

/* start mi dice quanti valori precedono il sottoalbero corrente  */
int bilanciato (Nodo * albero){
	int destra = 0, sinistra = 0;
	
	if(albero==NULL) return 1; //un albero vuoto è bilanciato
	
	if(albero->figlio_sx != NULL) sinistra = bilanciato(albero->figlio_sx);
	if(sinistra == -1) return -1; //il sottoalbero sinistro non è bilanciato
	if(albero->figlio_dx != NULL) destra = bilanciato(albero->figlio_dx);	
	if (destra == -1) return -1; //il sottoalbero destro non è bilanciato
	if(sinistra < destra / 2 || destra < sinistra / 2) return -1; //il sottoalbero più piccolo ha meno della metà dei nodi del più grande
	return (sinistra+destra+1); //restituisco il numero di nodi del mio sottoalbero
}
void stampa_inordine (Nodo * albero){
	if (albero == NULL) return;
	stampa_inordine(albero->figlio_sx);
	printf(" %d", albero->val);
	stampa_inordine(albero->figlio_dx);
}

int main () {
	Nodo * albero, *p;
	
	albero=NULL;
	p=NULL;
	
	albero=NULL;
	p=NULL;
	
	albero= malloc(sizeof(Nodo));
	albero->val=-1;
	albero ->figlio_sx = NULL;
	albero ->figlio_dx = NULL;
	
	albero -> figlio_sx = malloc(sizeof(Nodo));
	p=albero->figlio_sx;
	
	p->val=-1;
	p ->figlio_sx = NULL;
	p ->figlio_dx = NULL;


	
	p -> figlio_dx = malloc(sizeof(Nodo));
	p=p->figlio_dx;
	p->val=-1;
	p ->figlio_sx = NULL;
	p ->figlio_dx = NULL;

	
	/*albero -> figlio_dx = malloc(sizeof(Nodo));
	p=albero->figlio_dx;
	
	p->val=-1;
	p ->figlio_sx = NULL;
	p ->figlio_dx = NULL;*/

	
	printf("%d\n", bilanciato(albero));
}
