#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
  long val;
  struct nodo * figlio_sx;
  struct nodo * figlio_dx;
} Nodo;

//userò il valore di ritorno per mantenere la somma dei valori del sottoalbero
long exp_ (Nodo * albero){
	
	long sinistro, destro;
	sinistro = 0;
	destro = 0;
	
	if(albero==NULL) return 1; //l'albero vuoto è ok
	
	if(albero-> figlio_sx != NULL) sinistro = exp_(albero-> figlio_sx);
	if (sinistro == -1 || (albero->figlio_sx != NULL &&albero->val < sinistro)) return -1;
	destro = exp_(albero->figlio_dx);
	if (destro == -1 || (albero->figlio_dx!= NULL && destro < albero->val)) return -1;
	else return (sinistro+destro+albero->val);
}

void stampa_inordine (Nodo * albero){
	if (albero == NULL) return;
	stampa_inordine(albero->figlio_sx);
	printf(" %d", albero->val);
	stampa_inordine(albero->figlio_dx);
}

int main () {
	Nodo * albero;
	
	albero=NULL;
	
	exp_(albero);
	
}
