#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
  int * val;
  struct nodo * succ;
} Nodo;

int * trova_massimo(int * vett, int * flags) {
	int max = -1;
	int i = 0;
	while(vett[i]!=-1) {
		if(flags[i]==0 && (max == -1 || vett[max]< vett[i]))
			max = i;
		i++;
	}
	if (max != -1) {
		flags[max] = 1;
		return (&vett[max]);
	}
	return NULL;
}

Nodo * lista_ordinata(int * v, int * f){
	Nodo * s, * t;
	int * el;
	
	s = NULL;
	t = NULL;
	
	while (el = trova_massimo(v, f),  el != NULL) {
		t = malloc(sizeof(Nodo));
		t->val = el;
		t->succ = s;
		s = t;
	}
	
	return s;
}

void stampa_lista(Nodo * l){
	if (l== NULL) return;
	printf(" %d", *(l->val));
	stampa_lista(l->succ);
}

int main () {
	Nodo * lista = NULL;
	
	int v[] = {1, 4, 15, 25, 40, 1, 23, 48, 12, 1, 0, -1};
	int f[11] = {0};
	
	lista = lista_ordinata(v,f);
	stampa_lista(lista);
	
	printf("\n");
}
