#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
  long val;
  struct nodo * succ;
} Nodo;



long somma_e_elimina(Nodo ** l, int inizio, int quanti){
	
	long v;
	Nodo * temp;
	
	if (*l == NULL || quanti == 0) return 0;
	
	if(inizio >1) return somma_e_elimina(&((*l)->succ), inizio-1, quanti);
	
	temp = *l;
	*l=(*l)->succ;
	v=temp->val;
	
	free(temp);
	return(v+ somma_e_elimina(l, 1, quanti-1));
}

void stampa_lista(Nodo * l){
	if (l==NULL) return;
	
	printf(" %ld", l->val);
	stampa_lista(l->succ);
	
}
int main () {
	Nodo * lista = NULL;
	Nodo * tmp = NULL, * prev = NULL;
	int i;
	
	
	for (i=1; i<=10; i++){
		tmp = malloc(sizeof(Nodo));
		tmp->val = i;
		tmp->succ = NULL;
		if (lista == NULL) lista = tmp;
		if(prev!= NULL) prev->succ = tmp;
		prev = tmp;
	}
	printf("Lista iniziale:\n");
	stampa_lista(lista);

	printf("\nSomma elementi modificati da somma_e_elimina(&lista, 3, 4): %ld\n", somma_e_elimina(&lista, 3, 4));
	printf("Lista modificata:\n");
	stampa_lista(lista);
	printf("\n");
}
