#include <stdio.h>
#include <stdlib.h>

typedef struct nodo {
  int * val;
  struct nodo * succ;
} Nodo;

int * trova_minimo(int * vett, int * flags) {
	int min = -1;
	int i = 0;
	while(vett[i]!=-1) {
		if(flags[i]==0 && (min == -1 || vett[min] >vett[i]))
			min = i;
		i++;
	}
	if (min != -1) {
		flags[min] = 1;
		return (&vett[min]);
	}
	return NULL;
}

Nodo * lista_ordinata(int * v, int * f){
	Nodo * h, * t;
	int * el;
	
	h = NULL;
	t = NULL;
	
	while (el = trova_minimo(v, f),  el != NULL) {
		
		if(h==NULL) {
			h = malloc(sizeof(Nodo));
			h->val = el;
			h -> succ = NULL;
			t = h;
		} else{
			t->succ = malloc(sizeof(Nodo));
			t = t->succ;
			t->val = el;
			t->succ = NULL;
		}
		
	}
	
	return h;
}

void stampa_lista(Nodo * l){
	if (l== NULL) return;
	printf(" %d", *(l->val));
	stampa_lista(l->succ);
}

int main () {
	Nodo * lista = NULL;
	
	int v[] = {1, 4, 15, 25, 40, 1, 23, 48, 12, 1, 0, -1};
	int f[11] = {0};
	
	lista = lista_ordinata(v,f);
	stampa_lista(lista);
	
	printf("\n");
}